package no.ntnu.idatt1002.demo.data.Economics;

import java.util.ArrayList;

/**
 * ItemOverview is an abstract class for storing and getting.
 * information on items. Superclass for Income- and ExpenseOverview.
 */
public class ItemOverview<T>{
    ArrayList<T> items;

    /**
     * An "empty" class constructor.
     */
    public ItemOverview() {
        this.items = new ArrayList<>();   //ArrayList for storing item´s
    }

    /**
     * Class constructor that takes in an ArrayList of Item´s as argument.
     * @param items An ArrayList of the Item´s you want to overview.
     */
    public ItemOverview(ArrayList<T> items) {
        this.items = items;
    }

    /**
     * Get an ArrayList of every item.
     * @return item ArrayList.
     */
    public ArrayList<T> getItems() {
        return items;
    }

    public void addItem(T newItem){
        if(items.contains(newItem)){
            throw new IllegalArgumentException("This item is already registered");
        }
        items.add(newItem);
    }



    /**
     * Get the sum of all Item´s in items.
     * @return Sum of all Item´s.
     */
    public double getTotalSum(){
        ArrayList<Item> castedItems = (ArrayList<Item>) items;
        return castedItems.stream().map(Item::getAmount).mapToDouble(Double::doubleValue).sum();
    }
}
